QGIS Application - Bug report #3507
built-in spatialindex conflicts with external libspatialindex
2011-02-19 11:10 PM - rustychris -

Status: Closed

Priority: Low

Assignee:

Category: Python plugins

Affected QGIS version:master Regression?: No

Operating System: Debian Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed/implemented
Crashes QGIS or corrupls data: Copied to github as #: 13567
Description

libspatialindex is used by the python rtree module, but when this module is loaded from within a QGIS python plugin, the symbols from the
builtin copy of spatialindex collide and render the python rtree module inoperable.

How to reproduce: install the rtree python module. Start QGIS and open a python console:

>>> import rtree

>>> p = rtree.index.Property()
>>> p.set_storage(0)

True

>>> p.get_storage()

1

>>>

Stepping through in gdb shows that libspatialindex.so:Tools::PropertySet::getProperty is shadowed by a function of the same name in
libggis_core.so.

History

#1 - 2011-03-09 07:30 AM - Volker Fréhlich

By updating the [[Spatiallndex]] wrapper and amending CMakeLists and creating a Cmake script, | managed to build QGIS with a systemwide
libspatialindex.

Wonder proposed to update the shipped copy of [[Spatiallndex]] and update the wrapper, so the user has the choice to use either lib.

Doing so, would help your problem, | suppose.

| can provide a patch, but I'm not a 100% sure, everything works correct or that my patch is sound, as | am no C++ programmer. Maybe we should do that
after 1.7.

#2 - 2011-03-10 03:22 PM - Borys Jurgiel

The sooner you send it, the sooner JEF&Marco&Tim&Martin will be able to review it ;-)

#3 - 2011-07-25 01:27 PM - Volker Frohlich
- Pull Request or Patch supplied set to No

Please see #4111

#4 - 2011-12-16 01:49 PM - Giovanni Manghi
- Target version changed from Version 1.7.0 to Version 1.7.4

#5 - 2012-04-16 06:26 AM - Paolo Cavallini
- Affected QGIS version set to master
- Crashes QGIS or corrupts data set to No

- Target version changed from Version 1.7.4 to Version 1.8.0

#6 - 2012-09-04 11:59 AM - Paolo Cavallini

- Target version changed from Version 1.8.0 to Version 2.0.0

#7 - 2012-09-16 03:42 PM - Borys Jurgiel
- Assignee deleted (Borys Jurgiel)

#8 - 2014-06-28 07:38 AM - Jiirgen Fischer
- Target version changed from Version 2.0.0 to Future Release - Lower Priority

#9 - 2015-11-20 02:52 AM - Médéric RIBREUX

- Status changed from Open to Closed

- Resolution set to fixed/implemented

Hello, bug triage...

with QGIS 2.13 on Debian, there is no conflict: p.get_storage() returns 0.

| am closing this bug.
